/*
 *
 * Copyright  2004, University of Washington, 
 * Department of Computer Science and Engineering. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 * 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 *
 * 3. Neither name of the University of Washington, Department of Computer 
 * Science and Engineering nor the names of its contributors may be used to 
 * endorse or promote products derived from this software without specific 
 * prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR 
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 *
 */

//*******************************************************************//
//You will need to import ws2_32.lib for MoteConn work.
//In MSVS you can right click on the project, select configuration properties / linker / input / additional dependencies and type "ws2_32.lib" in there. 
//
//You will also need to insure that winsock2.h is included before winsock.h (note: windows.h includes winsock.h)
//*******************************************************************//
#include <winsock2.h>
#include <iostream>

using namespace std;


class MoteConn
{
public:
	MoteConn(void);  	// constructor
	~MoteConn(void);	// destructor

	/* establishes a connection to SerialForwarder 
	 * Parameters: 
			ip: pointer to a string that contains the IP number
			portNum: port number we're connecting to
	 * Returns: if successfully connected
	 */
	bool connectMoteSF(char* ip, int portNum);
	
	/* sends an array of bytes to serial forwarder
	 * the array should follow TOSMsg conventions by starting with the header information
	 * Parameters: 
			bytesToSend: pointer to packet array
			numBytes: number of bytes to send/length of bytesToSend
	 * Returns: number of bytes that were sent
	 */
	int sendPacket(char* bytesToSend, int numBytes);

private:
	WSADATA m_wsaData;
	SOCKET m_moteSFSocket;

};
